#Copyright (c) 2018 Vereign AG [https://www.vereign.com]
#
#This is free software: you can redistribute it and/or modify
#it under the terms of the GNU Affero General Public License as
#published by the Free Software Foundation, either version 3 of the
#License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Affero General Public License for more details.
#
#You should have received a copy of the GNU Affero General Public License
#along with this program. If not, see <http://www.gnu.org/licenses/>.

#https://gaiax.vereign.com/tsa/signer/v1/presentation/proof
#Author: Georgi Michev georgi.michev@vereign.com

@rest @all @tsa @signer
Feature: API - TSA - Signer presentation proof - v1/presentation/proof POST
  As user
  I want to create a presentation proof
  So the presentation can be verified

  Background:
    Given we are testing the TSA Signer Api

  Scenario: TSA - create presentation proof - Positive
    When I load the REST request {Presentation.json} with profile {for_proof}
    When I create presentation proof via TSA Signer API
    And the status code should be {200}
    And the response is valid according to the {Signer_PresentationProof_schema.json} REST schema
    And the field {proof.verificationMethod} has the value {did:web:gaiax.vereign.com:tsa:policy:policy:example:returnDID:1.0:evaluation#key1}

  Scenario: TSA - create presentation proof - Positive
    When I load the REST request {Presentation.json} with profile {for_proof_alumni}
    When I create presentation proof via TSA Signer API
    And the status code should be {200}
    And the response is valid according to the {Signer_PresentationProof_schema_alumni.json} REST schema

  Scenario: TSA - create presentation proof missing ID - Positive
    When I load the REST request {Presentation.json} with profile {for_proof_missing_ID}
    When I create presentation proof via TSA Signer API
    And the status code should be {200}
    And the response is valid according to the {Signer_PresentationProof_schema.json} REST schema
    And the field {proof.verificationMethod} has the value {did:web:gaiax.vereign.com:tsa:policy:policy:example:returnDID:1.0:evaluation#key1}

  @negative
  Scenario: TSA - validate presentation proof with empty body - Negative
    When I set the following request body {{}}
    When I create presentation proof via TSA Signer API
    And the status code should be {400}

  @negative
  Scenario: TSA - create presentation proof with incorrect ID (space) - Negative
    When I load the REST request {Presentation.json} with profile {for_proof_incorrect_ID_space}
    When I create presentation proof via TSA Signer API
    And the status code should be {400}
    And the field {message} has the value {invalid format of subject id}

  @negative
  Scenario: TSA - create presentation proof with incorrect ID (symbols) - Negative
    When I load the REST request {Presentation.json} with profile {for_proof_incorrect_ID_symbols}
    When I create presentation proof via TSA Signer API
    And the status code should be {400}
    And the field {message} has the value {invalid format of subject id}
